/**
 * Saeki(Nekketu Saiten Kyousi Saeki)
 * (c) Kenta Cho (cs8k-cyu@asahi-net.or.jp)
 * http://www.asahi-net.or.jp/~cs8k-cyu/
 *
 * drawpaper.c(draw test paper)
 */

Blank blank[10];
int blankNmb;

char toi[3] = {""};

// number of question messages
#define MONGON_NMB 12

char mongon[MONGON_NMB][20] = {
  "ȉ̖",
  "ƂH",
  "󗓂߂Ȃ",
  "ȂƂȂ",
  "낵",
  "̂Ȃ݂́H",
  "ł",
  "Ȃ",
  "K؂Ȃ̂",
  "Ă܂",
  "肢܂",
  "fB[S["};

int calcPrmMax(int rnk) {
  int fig = randN(rnk);
  switch ( fig ) {
  case 0:
    return 9;
  case 1:
    return 99;
  default:
    return 999;
  }
}

static void clearPaper() {
  RectangleType rct;
  rct.topLeft.x = 0;
  rct.topLeft.y = PEN_TOP_Y;
  rct.extent.x = 160;
  rct.extent.y = 160-PEN_TOP_Y;
  WinEraseRectangle(&rct, 0);
}

static void drawPaper(int lv) {
  RectangleType rct;
  int x, y = 2, ansSpc = randN(2)+2;
  char msg[32], nmbStr[5];
  int corcPct = randN(50) + 30;
  char opStr[4][4] = {" + ", " - ", " * ", " / "};

  rct.topLeft.x = 0;
  rct.topLeft.y = PEN_TOP_Y;
  rct.extent.x = 160;
  rct.extent.y = PEN_BOTTOM_Y-PEN_TOP_Y+2;
  WinEraseRectangle(&rct, 0);

  if ( LEFT_HAND ) {
    x = 0;
    WinDrawLine(135, PEN_TOP_Y, 135, PEN_BOTTOM_Y);
  } else {
    x = 30;
    WinDrawLine(25, PEN_TOP_Y, 25, PEN_BOTTOM_Y);
  }
  blankNmb = 0; 
  y += randN(2);
  StrCopy(msg, toi);
  StrIToA(nmbStr, randN(99)+1);
  StrCat(msg, nmbStr);
  StrCat(msg, "  ");
  StrCat(msg, mongon[randN(MONGON_NMB)]);
  WinDrawChars(msg, StrLen(msg), x, y*10);
  y += randN(2)+2;
  
  while ( y < 14 ) {
    int prm[3];
    int blkAns;
    int blkIdx = randN(3);

    int ltx;
    int rnk;
    int i;
    int opNmb;

    rnk = (int)(lv/10)+1; if ( rnk > 4 ) rnk = 4;
    opNmb = randN(rnk);
    switch ( opNmb ) {
    case 0:
      rnk = calcPrmMax((int)(lv/15)+1);
      prm[0] = randN(rnk)+1;
      prm[1] = randN(rnk)+1;
      prm[2] = prm[0] + prm[1];
      break;
    case 1:
      rnk = calcPrmMax((int)(lv/20)+1);
      prm[1] = randN(rnk)+1;
      prm[2] = randN(rnk)+1;
      prm[0] = prm[1] + prm[2];
      break;
    case 2:
      rnk = calcPrmMax((int)(lv/30)+1);
      if ( rnk > 99 ) rnk = 99;
      prm[0] = randN(rnk)+1;
      prm[1] = randN(rnk)+1;
      prm[2] = prm[0] * prm[1];
      break;
    case 3:
      rnk = calcPrmMax((int)(lv/40)+1);
      if ( rnk > 99 ) rnk = 99;
      prm[1] = randN(rnk)+1;
      prm[2] = randN(rnk)+1;
      prm[0] = prm[1] * prm[2];
      break;
    }
    blkAns = prm[blkIdx];

    if ( randN(100) < corcPct ) {
      blank[blankNmb].corc = TRUE;
    } else {
      blank[blankNmb].corc = FALSE;
      if ( prm[blkIdx] < 10 ) {
	prm[blkIdx] = randN(9)+1;
      } else if ( prm[blkIdx] < 20 ) {
	prm[blkIdx] = randN(19)+1;
      } else if ( prm[blkIdx] < 100 ) {
	prm[blkIdx] = randN(99)+1;
      } else {
	prm[blkIdx] += randN(200)-99;
      }
      if ( prm[blkIdx] == blkAns ) {
	prm[blkIdx]++;
      }
    }
    StrCopy(msg, "  ");
    StrIToA(nmbStr, blankNmb+1);
    StrCat(msg, nmbStr);
    StrCat(msg, ".  ");
    for ( i=0 ; i<3 ; i++ ) {
      if ( blkIdx == i ) {
	StrCat(msg, "(");
	ltx = x + FntCharsWidth(msg, StrLen(msg));
	blank[blankNmb].x = ltx; blank[blankNmb].y = y*10;
	WinDrawChars(msg, StrLen(msg), x, y*10);
	StrIToA(msg, prm[blkIdx]);
	WinDrawChars(msg, StrLen(msg),
		     ltx + randN((40-FntCharsWidth(msg, StrLen(msg)))),
		     y*10-1+randN(3));
	StrIToA(msg, blkAns);
	if ( LEFT_HAND ) {
	  WinDrawChars(msg, StrLen(msg), 140, y*10);
	} else {
	  WinDrawChars(msg, StrLen(msg), 0, y*10);
	}
	StrCopy(msg, ")");
      } else {
	StrIToA(nmbStr, prm[i]);
	StrCat(msg, nmbStr);
      }
      switch (i) {
      case 0:
	StrCat(msg, opStr[opNmb]);
	break;
      case 1:
	StrCat(msg, " = ");
	break;
      }
    }
    WinDrawChars(msg, StrLen(msg), ltx+40, y*10);
    blankNmb++;
    y += ansSpc;
    if ( randN(100) < 30 ) break;
  }
}
